/*****************************/
/* kChat v1.0b		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.net.*;

public class kChatApplet extends Applet implements AdjustmentListener, KeyListener {
  public static int sizeX = 600;
  public static int sizeY = 470;
  public static kChatNet net = null;
  public static String login = "";
  public static kChatChannel chanWnd = null;
  public static kChatChannel chanWndModer = null;
  public static Scrollbar sbar = null;
  public static Scrollbar msbar = null;
  public static TextArea input = null;
  public static String msgColor = "black";
  public static List nList = null;
  public static boolean moderate = false;
  public static Image bgImage = null;
  public static Image bgImageModer = null;
  public static String moderatorNick = "";
  public static Frame moderFr = null;
  private static String host = new String();

public void init() {
// try { 
//    bgImage = getImage(new URL("http://www.sports.pl/graph/chatlo.jpg")); 
//    bgImageModer = this.getImage(new URL("http://www.sports.pl/graph/chatlomoder.jpg")); }
// catch (java.net.MalformedURLException e) {}

 setSize(sizeX, sizeY);
 setBackground(Color.white);

 chanWnd = new kChatChannel(sizeX-130,sizeY-60);
 chanWnd.setFont(new Font("",Font.PLAIN,12));
 chanWnd.setBackground(Color.white);
 chanWnd.setBackgroundImage(bgImage);

 sbar = new Scrollbar(Scrollbar.VERTICAL,0,1,0,0);    
 sbar.addAdjustmentListener(this);
 sbar.setSize(sbar.getSize().width,sizeY-150);

 chanWnd.setScroller(sbar);

 nList = new List();

 input = new TextArea("",2,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
 input.setSize(100,50);
 input.setFont(new Font("",Font.PLAIN,12));
 input.addKeyListener(this);

 Panel panel = new Panel(); 
 Panel p1 = new Panel();
 Panel p2 = new Panel();

 p1.setLayout(new BorderLayout());

 p1.add(chanWnd, BorderLayout.WEST);
 p1.add(sbar, BorderLayout.CENTER);
 p1.add(nList, BorderLayout.EAST);

 p2.setLayout(new BorderLayout());
 p2.add(input, BorderLayout.CENTER);

 panel.setLayout(new BorderLayout());
 panel.add(p1, BorderLayout.CENTER);
 panel.add(p2, BorderLayout.SOUTH);

 add(panel);

 msbar = new Scrollbar(Scrollbar.VERTICAL,0,1,0,0);    
 msbar.addAdjustmentListener(this);
 msbar.setSize(msbar.getSize().width,sizeY);

 login = getParameter("login");
 msgColor = getParameter("color");
 net = new kChatNet();
 net.connect(getCodeBase().getHost());
 host = getCodeBase().getHost();
 net.send("*LOGIN|"+login+"|SYSTEM|");
 net.send("CHECK");
 new kChatPing("",net).start();
}


public static void moderWinOpen()
    {
    Panel pwm = new Panel();
    pwm.setLayout(new BorderLayout());
//    pwm.setSize(sizeX-130,sizeY-60);

    moderFr = new Frame("Moderacja kanalem");
    moderFr.setSize(sizeX-108,sizeY-18);
    moderFr.setResizable(true);
    moderFr.setLayout(new BorderLayout());
    
    chanWndModer = new kChatChannel(sizeX-130,sizeY-60);
//    chanWndModer = new kChatChannel(sizeX-130+40,sizeY-60);
    chanWndModer.setFont(new Font("",Font.PLAIN,12));
    chanWndModer.setScroller(msbar);
    chanWndModer.setBackgroundImage(bgImageModer);

    pwm.add(chanWndModer,BorderLayout.WEST);
    pwm.add(msbar, BorderLayout.EAST);
    moderFr.add(pwm);
    moderFr.setVisible(true);
    }

public static void reconect()
    {
//    net.send("CLOSE");
//    chanWnd.appendText("Blad w komunikacji","black");
    net.disconnect();
    net.connect(host);
    net.send("*LOGIN|"+login+"|SYSTEM|");
    net.send("CHECK");
    }


public void adjustmentValueChanged(AdjustmentEvent e) {
    int typ = e.getAdjustmentType();
    if (e.getAdjustable() == sbar)
	{
        chanWnd.moveStart(e.getValue());
        if (typ == AdjustmentEvent.UNIT_DECREMENT) chanWnd.moveUp();
        if (typ == AdjustmentEvent.UNIT_INCREMENT) chanWnd.moveDown();
	}
	
    if (e.getAdjustable() == msbar)
	{
        chanWndModer.moveStart(e.getValue());
        if (typ == AdjustmentEvent.UNIT_DECREMENT) chanWndModer.moveUp();
        if (typ == AdjustmentEvent.UNIT_INCREMENT) chanWndModer.moveDown();
	}
    }

 public void keyTyped(KeyEvent e) {
	}
 public void keyPressed(KeyEvent e) {
	if ((e.getKeyCode() == KeyEvent.VK_ENTER) 
&& (input.getText().length()>0) && (!input.getText().equals("")))
		{ 
		boolean kick = false;
		  if (input.getText().startsWith("/K"))
		    {
		    String val = input.getText().substring(3,input.getText().length());
		    input.setText(""); 
		    input.setCaretPosition(0);
		    val.trim();
		    net.send("*KICK|"+val+"|");
		    kick = true;
		    }
		    
		  if (input.getText().startsWith("/MODERATOR"))
		    {
		    String val = input.getText().substring(11,input.getText().length());
		    val.trim();
		    String pass = val.substring(0,val.indexOf(":"));
		    String gosc = val.substring(val.indexOf(":")+1,val.length());
		    net.send("MODERATOR " + pass + ":" + gosc); 
		    } else
		    {
		    if (!kick)
		    if ((moderate) && (login.equals(moderatorNick)))
			net.send("*MSG|" + login + "|CHAN|Moderator : " + input.getText() + "|" + msgColor + "|"); 
			else
			net.send("*MSG|" + login + "|CHAN|" + input.getText() + "|" + msgColor + "|"); 
		    }
		  input.setText(""); 
		  input.setCaretPosition(0);
		}
	}
 public void keyReleased(KeyEvent e) 
	{
	if ((e.getKeyCode() == KeyEvent.VK_ENTER) 
&& (input.getText().length()>0) && (!input.getText().equals("")))
		{
		input.setText(""); 
		input.setCaretPosition(0); 
		}
	}

public void update(Graphics g) { paint(g); }
public void start(Graphics g) { repaint(); }
public void stop(Graphics g) { repaint(); }
public void paint(Graphics g) { super.paint(g); }
public synchronized void destroy() { net.send("CLOSE"); }

}
