/*****************************/
/* kChat v1.0b		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.*;

public class kChatProtocol {
    private static kChatParse parseCommand = new kChatParse();
    
    public static void parse(String buf) {
    if (buf.startsWith("*") && (parseCommand.getChatCommand(buf).equals("MSG"))) 
{
        String s = "";
	if (parseCommand.getCommandWhere(buf).equals("CHAN")) 
{

	    // jesli moderowany i jest to od moderatora
	    if ((kChatApplet.moderate) && (parseCommand.getCommandWho(buf).equals(kChatApplet.moderatorNick)))
		{
		s = ""+parseCommand.getCommandText(buf);
 // to pisze moderator
		kChatApplet.chanWnd.appendText(s,parseCommand.getCommandColor(buf));
		}

	    // jesli moderowany i nie jest to od moderatora
	    if ((kChatApplet.moderate) && (!parseCommand.getCommandWho(buf).equals(kChatApplet.moderatorNick)))
		{
        	s = "<"+parseCommand.getCommandWho(buf)+"> "+parseCommand.getCommandText(buf);
		kChatApplet.chanWnd.appendText(s,parseCommand.getCommandColor(buf));
		}
		
	    // jesli nie moderowany 
	    if (!kChatApplet.moderate)
		{
        	s = "<"+parseCommand.getCommandWho(buf)+"> "+parseCommand.getCommandText(buf);
		kChatApplet.chanWnd.appendText(s,parseCommand.getCommandColor(buf));
		}
	    

        }
	// priv, lub do moderatora
	if (parseCommand.getCommandWhere(buf).equals(kChatApplet.login)) 
{
	    if (kChatApplet.moderate) { // to pisze ludek do moderatora
            s = "<"+parseCommand.getCommandWho(buf)+"> " + parseCommand.getCommandText(buf);
	    kChatApplet.chanWndModer.appendText(s,parseCommand.getCommandColor(buf));
	    }
	    
	}
    }
    
    if (buf.startsWith("*") && (parseCommand.getChatCommand(buf).equals("LIST"))) 
{
	if (kChatApplet.nList == null) kChatApplet.nList = new List();
	
	int start = 5;	int end = 5;
	while (buf.indexOf("|",start+1) != -1) {
	    start = end+1;
	    end   = buf.indexOf("|",start+1);
	    if ((start<end) && (!buf.substring(start,end).equals(kChatApplet.login))) kChatApplet.nList.addItem(buf.substring(start,end));
	    }
    }

    if (buf.startsWith("*") && (parseCommand.getChatCommand(buf).equals("JOIN"))) 
{
	String n = buf.substring(6,buf.indexOf("|",7));
	kChatApplet.nList.addItem(n);
	kChatApplet.chanWnd.appendText(n + " przyszedl","gray");
    }

    if (buf.startsWith("*") && (parseCommand.getChatCommand(buf).equals("QUIT"))) 
{
	String n = buf.substring(buf.indexOf("|",0)+1,buf.indexOf("|",buf.indexOf("|",0)+1));
	for (int i=0;i<kChatApplet.nList.getItemCount();i++) {   
		if ((kChatApplet.nList != null) && (kChatApplet.nList.getItem(i).equals(n))) 
		    kChatApplet.nList.delItem(i); 
	    }
	kChatApplet.chanWnd.appendText("" + n + " wyszedl","black");
    }

    if (buf.startsWith("*MODERATED")) 
{
	if (buf.substring(11,13).equals("NO"))	
	    {
	    kChatApplet.moderate=false;
	    kChatApplet.moderatorNick = "";
	    kChatApplet.chanWnd.appendText("Kanal nie jest moderowany" ,"gray");
	    }
	    else 
	    {
	    kChatApplet.moderate=true;
	    kChatApplet.moderatorNick = buf.substring( buf.indexOf("|",11)+1,buf.indexOf("|",buf.indexOf("|",11)+1)  );
	    kChatApplet.chanWnd.appendText("Kanal moderowany przez " + kChatApplet.moderatorNick,"gray");
	    } 
    }

    if (buf.startsWith("YOUAREMODERATOR")) 
{
	    kChatApplet.moderate=true;
	    kChatApplet.chanWnd.appendText("Jestes Moderatorem","red");
	    kChatApplet.moderWinOpen();
	    kChatApplet.chanWndModer.moderatorMode=true;
    }
    if (buf.startsWith("LOGIN")) 
{
	    String s = buf.substring(buf.indexOf("|",0)+1,buf.indexOf("|",buf.indexOf("|",0)+1));
	    if (s.equals("OK"))
		{
		kChatApplet.chanWnd.appendText("Witam na Czacie","black");
		kChatApplet.net.send("*MODERATED");
		}
	    if (s.equals("NICK BUSY"))
		{
		kChatApplet.chanWnd.appendText("Login zajety sproboj inny","black");
		}

	}
    if (buf.startsWith("*KICK")) 
{
	kChatApplet.chanWnd.appendText("Zostales wyrzucony przez moderatora !!!","black");
	kChatApplet.net.send("CLOSE\r\n");
    }



  }
}