/*****************************/
/* kChat v1.0b		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.net.*;
import java.io.*;

public class kChatServerThread extends Thread
{
    Socket	   clientS = null;
    BufferedReader br = null;
    PrintWriter    pw = null;
    String  login = "";

    public kChatServerThread(Socket cl)
    {
    super("kChatServerThread");
    this.clientS = cl;
    }

    public void run()
    {
    try {
	br = new BufferedReader(new InputStreamReader(clientS.getInputStream()));
	pw = new PrintWriter(new BufferedOutputStream(clientS.getOutputStream(), 1024), false);
	pw.println("WELCOME " + clientS.getInetAddress().getHostAddress()+"\r\n");
	pw.flush();
	
	String liniaWe, liniaWy;
	liniaWy = "";
	while ((liniaWe = br.readLine()) != null) 
	    {
	    liniaWy = odpowiedzSerwera(liniaWe);
    	    if (!liniaWy.equals("")) {
	         pw.println(liniaWy+"\r\n");
	         pw.flush();
        	 }
	    if (liniaWy.equals("BYE")) break;
	    }

	pw.close();
	br.close();
	if ((liniaWy == null) || (!liniaWy.equals("BYE")))
		kChatSystem.quitFromSystem(login);
	clientS.close();
	} 
	catch (IOException e) { 
//	    kChatSystem.quitFromSystem(login);
	    e.printStackTrace();	    
	    }
    }
    
    private String getChatCommand(String s)
    { 
    int pozcE = s.indexOf("|");
    if (pozcE == -1) return("");
    return(new String(s.substring(1,pozcE)));  
    }
    
    private String getCommandWho(String s)
    { 
    int pozcE = s.indexOf("|");
    int pozwE = s.indexOf("|",pozcE+1);
    if ((pozcE == -1) || (pozwE == -1)) return("");
    return(new String(s.substring(pozcE+1,pozwE))); 
    }

    private String getCommandWhere(String s)
    { 
    int pozcE = s.indexOf("|");
    int pozwE = s.indexOf("|",pozcE+1);
    int pozwhE = s.indexOf("|",pozwE+1);
    if ((pozcE == -1) || (pozwE == -1) || (pozwhE == -1)) return("");
    return(new String(s.substring(pozwE+1,pozwhE))); 
    }

    private String getCommandText(String s)
    { 
    int pozcE = s.indexOf("|");
    int pozwE = s.indexOf("|",pozcE+1);
    int pozwhE = s.indexOf("|",pozwE+1);
    int poztE = s.indexOf("|",pozwhE+1);
    if ((pozcE == -1) || (pozwE == -1) || (pozwhE == -1) || (poztE == -1)) return("");
    return(new String(s.substring(pozwhE+1,poztE))); 
    }

    private String getCommandColor(String s)
    { 
    int pozcE = s.indexOf("|");
    int pozwE = s.indexOf("|",pozcE+1);
    int pozwhE = s.indexOf("|",pozwE+1);
    int poztE = s.indexOf("|",pozwhE+1);
    int pozcolE = s.indexOf("|",poztE+1);
    if ((pozcE == -1) || (pozwE == -1) || (pozwhE == -1) || (poztE == -1) || (pozcolE == -1)) return("");
    return(new String(s.substring(poztE+1,pozcolE))); 
    }
    
/*    
     *ACTION|WHO|WHERE|TEKST|CHECK
     WHERE   = nick || CHAN || SYSTEM
     WHO     = nick || CHAN || SYSTEM
     ACTION  = *LOGIN || *MSG
 || *LIST
     login   = *LOGIN|krzak|SYSTEM|
     mezg    = *MSG|kto|gdzie|tekst|kolor|
     ktojest = *LIST|NULL| || *LIST|nick1|nick2|nick3|

*/
    public String odpowiedzSerwera(String ln)
    {
    if ((ln == null) || (ln.equals(null)) || (ln.equals(""))) return("UNKNOWN COMMAND");
    if (ln.equals("CLOSE")) {
			kChatSystem.quitFromSystem(login);
			return("BYE");
			}
    if (ln.equals("WHOAMI")) return(clientS.getInetAddress().getHostAddress());	
    if (ln.equals("*MODERATED")) if (kChatSystem.moderated) return("*MODERATED|YES|"+kChatSystem.moderatorNick+"|"); else return("*MODERATED|NO|");

    if (ln.startsWith("*") && (getChatCommand(ln).equals("LOGIN"))) {
	       if ( (getCommandWhere(ln).equals("SYSTEM"))  && 
		    (getCommandText(ln).equals("")) &&
	            (kChatSystem.loginToSystem(getCommandWho(ln),this))
 ) 
		    {
		    login = getCommandWho(ln);
            	    return("LOGIN|OK|"); 
		    }
                  else 
            	    return("LOGIN|NICK BUSY|"); 
//            	    return("ERROR|LOGIN FAILED|" + kChatSystem.lastError); 
    }
    
    if (ln.startsWith("*") && (getChatCommand(ln).equals("MSG")))
        {
        if (login.equals("")) return("ERROR|LOGIN FIRST|");
	if (getCommandText(ln).equals("")) return("ERROR|UNKNOWN|");
	kChatSystem.sendMsgTo(login,getCommandWhere(ln),getCommandText(ln),getCommandColor(ln));
        return("");
        }


    if (ln.equals("CHECK")) {
	String s = "*LIST|";
	if ((kChatSystem.clientList == null) || (kChatSystem.clientList.size()<0))return("*LIST|NULL|");
        for (int i = 0; i < kChatSystem.clientList.size(); i++) {
	    kChatClass tmpE = (kChatClass)kChatSystem.clientList.elementAt(i);
	    s = s + tmpE.login + "|";
	    }
	return(s);
         }

    if (ln.startsWith("MODERATOR")) {
	if ((ln.length()<=9) || (login.equals("")) || (ln.indexOf(":",0) == -1)) return("");
	String typedPass = "";
	typedPass = ln.substring(10,ln.length());
	typedPass.trim();
	
	try {
	FileReader fr = new FileReader("./moderpass");
	BufferedReader frb  = new BufferedReader(fr);
	String filePass = frb.readLine();
	if (typedPass.substring(0,typedPass.indexOf(":",0)).equals(filePass)) { 
	    kChatSystem.moderated=true; 
	    String gosc = typedPass.substring(typedPass.indexOf(":",0)+1,typedPass.length());
	    kChatSystem.moderatorNick=login;
	    kChatSystem.guestNick=gosc;
	    kChatSystem.sayToAll("*MODERATED|YES|"+kChatSystem.moderatorNick+"|");
	    return("YOUAREMODERATOR"); 
	    }
	} catch (IOException e) { e.printStackTrace(); }
    }
	
    if (ln.startsWith("PING")) {
	return("PONG");
    }
    
    if (ln.startsWith("*KICK")) {
	if ((kChatSystem.moderated) && (kChatSystem.moderatorNick.equals(login)))
	    {
	    String s = ln.substring(ln.indexOf("|",0)+1,ln.indexOf("|",ln.indexOf("|",0)+1));
	    for (int i = 0; i < kChatSystem.clientList.size(); i++) {
				kChatClass tmpE = (kChatClass)kChatSystem.clientList.elementAt(i);
				if (tmpE.login.equals(s))  
				    { 
				    tmpE.watek.pw.println("*KICK\r\n");
				    tmpE.watek.pw.flush();
				    }
				}
	    kChatSystem.quitFromSystem(s);
	    return("OK");
	    }
    }
	
    return("UNKNOWN COMMAND");
    }
}